package class7_2_TestsBroken;

import class7_2_TestsFixed.Test;

public class ConcreteTest implements Test {
    private final String name;
    private final Runnable runnable;

    public ConcreteTest(String name, Runnable runnable) {
        this.name = name;
        this.runnable = runnable;
    }

    @Override
    public String getName() {
        return name;
    }

    @Override
    public void run() {
        System.out.println("Testing "+name+".");
        try {
            runnable.run();
            System.out.println("Tested  "+name+" PASSED.");
        } catch (Exception e) {
            System.out.println("Error while testing "+name);
            e.printStackTrace(System.out);
            System.out.println("Tested  "+name+" FAILED.");
        }
    }
}
